<?php
/**
 * Created by PhpStorm.
 * User: Stefan
 * Date: 25.04.2015
 * Time: 19:36
 */


/**
 * Receives the title of a Wikipedia Page
 * Returns the amount of picutres on that site as JSON
 */
if (isset($_GET['title'])) {
    getAndPrintNumImages($_GET['title']);
    unset($_GET['title']);

    /**
     * Receives a JSON Object that contains two numbers and an action to perform
     * Returns result of the computation as JSON
     */
} elseif (isset($_POST['content'])) {
    $json = json_decode($_POST['content']);
    unset ($_POST['content']);
    $number1 = $json->number1;
    $number2 = $json->number2;
    $action = $json->action;
    doAndPrintArithmetic($number1, $number2, $action);


} else {
    echo 'Please call this website with GET or POST parameters!';
}

/**
 * Do the API call and print the amount of images
 */
function getAndPrintNumImages($title)
{
    $url = 'http://en.wikipedia.org/w/api.php?action=query&prop=images&imlimit=500&format=xml&titles=' . urlencode($title);
    $response = file_get_contents($url);
    $xml = simplexml_load_string($response);
    echo "{\"numImages\": " . sizeof($xml->query->pages->page->images->im) . "}";
}

/**
 * Determine the type of action and do the arithmetic
 */
function doAndPrintArithmetic($number1, $number2, $action)
{
    if (strcasecmp($action, "multiply") == 0) {
        doMultiply($number1, $number2);
    } elseif (strcasecmp($action, "add") == 0) {
        doAdd($number1, $number2);
    } elseif (strcasecmp($action, "divide") == 0) {
        doDivide($number1, $number2);
    } elseif (strcasecmp($action, "substract") == 0) {
        doSubstract($number1, $number2);
    } else {
        echo "Unknown action!";
    }
}

/**
 * @param $number1
 * @param $number2
 *
 * Multiply two numbers
 */
function doMultiply($number1, $number2)
{
    echo "{ \"result\": " . (intval($number1) * intval($number2)) . " }";
}

/**
 * @param $number1
 * @param $number2
 *
 * Add two numbers
 */
function doAdd($number1, $number2)
{
    echo "{ \"result\": " . (intval($number1) + intval($number2)) . " }";
}

/**
 * @param $number1
 * @param $number2
 *
 * Divide two numbers
 */
function doDivide($number1, $number2)
{
    echo "{ \"result\": " . (intval($number1) / intval($number2)) . " }";
}

/**
 * @param $number1
 * @param $number2
 *
 * Substract two numbers
 */
function doSubstract($number1, $number2)
{
    echo "{ \"result\": " . (intval($number1) - intval($number2)) . " }";
}